#!/usr/bin/wish

# -------------------------------------------------------------
#
wm title . "Run zwc on text files"
wm resizable .

wm minsize . 500 600
# -------------------------------------------------------------
# This is the unlabeled frame for the pull down menu
#
menu .menubar
menu .menubar.help 
.menubar add cascade -label "Help/details" -menu .menubar.help 
.menubar.help add command -label "About zwc_gui ..."    -command showAboutZwc_gui
.menubar.help add command -label "About zwc ..."        -command showAboutZwc
.menubar.help add command -label "About Zipf's Law ..." -command showAboutZipfsLaw
. configure -menu .menubar -width 500 -height 150

# -------------------------------------------------------------
# This is a labeled container for the input and output file boxes
#
set filenameFrame [labelframe .filename_frame -borderwidth 1 -text "Input and Output Files" ]

# -------------------------------------------------------------
# This is a labeled container for the Run Options, hyphen, and include digit selector frames
#
set optionsFrame  [labelframe .options_frame               -borderwidth 1 -text "Run Options"]
set optionsFrame1 [labelframe $optionsFrame.options_frame1 -borderwidth 1 -text "(-s)" ]
set optionsFrame3 [labelframe $optionsFrame.options_frame3 -borderwidth 1 -text "(-d)" ]

# -------------------------------------------------------------
# This is the labeled container for the Output Options frames:
#
set outputFrame   [labelframe .output_frame             -borderwidth 1 -text "Output Options"]
set csvFrame      [labelframe $outputFrame.csv_frame    -borderwidth 1 -text "(-c)"]
set allFrame      [labelframe $outputFrame.all_frame    -borderwidth 1 -text "(-a)"]
set plotFrame     [labelframe $outputFrame.plot_frame   -borderwidth 1 -text "Run GNUPlot?"]
set saveToFrame   [labelframe $outputFrame.saveTo_frame -borderwidth 1 -text "HTML summary?"]

# -------------------------------------------------------------
# This is the labeled container for the gnuplot Replotting Options:
#
set gnuplotFrame [labelframe .gnuplot_frame             -borderwidth 1 -text "WRPROF Replotting Options"]
set labelsFrame  [labelframe $gnuplotFrame.labels_frame -borderwidth 1 -text "Add labels?"]
set zoomFrame    [labelframe $gnuplotFrame.zoom_frame   -borderwidth 1 -text "Zoom in on range"]
set replot_button [button $gnuplotFrame.replot_button -text "WRPROF Replot"   -command {do_replot $outputdir $ipathandfilename $textFrame $xmin $xmax $ymax $includelabels} ]
pack $gnuplotFrame.replot_button -side right 

# -------------------------------------------------------------
# This is a labeled container for the Buttons to Click, program invocation options
#
set buttonFrame   [labelframe .button_frame   -borderwidth 1 -text "Buttons to Click"]

# -------------------------------------------------------------
# This is the unlabeled scrollbox text
#
set textFrame     [labelframe  .text_label_frame  -width 500 -borderwidth 1 ]
text .text_frame -wrap none -height 15
scrollbar .sbar_y -orient v
scrollbar .sbar_x -orient h
.text_frame conf -yscrollcommand {.sbar_y set} -xscrollcommand {.sbar_x set} 
.sbar_y conf -command {.text_frame yview}
.sbar_x conf -command {.text_frame xview}


#################################################################################
# Internal frames for each of the 6 frames above.
#################################################################################
#filenameFrame
set ipathandfilename textfiles/MrFeynman.txt

set ipathandfilename_input  [entry $filenameFrame.ipathandfilename_input  -textvariable ipathandfilename]
set ipathandfilename_prompt [label $filenameFrame.ipathandfilename_prompt -text "Input Filename (-f)" ]

set ofilename STDOUT
set ofilename_input  [entry $filenameFrame.ofilename_input  -textvariable ofilename]
set ofilename_prompt [label $filenameFrame.ofilename_prompt -text "Output Filename" ]

set outputdir outfiles
set outputdir_input  [entry $filenameFrame.outputdir_input  -textvariable outputdir]
set outputdir_prompt [label $filenameFrame.outputdir_prompt -text "Output Directory (-o)" ]

grid $filenameFrame.ipathandfilename_prompt -column 0 -row 0
grid $filenameFrame.ipathandfilename_input  -column 1 -row 0
grid $filenameFrame.ofilename_prompt -column 0 -row 1
grid $filenameFrame.ofilename_input  -column 1 -row 1
grid $filenameFrame.outputdir_prompt -column 0 -row 2
grid $filenameFrame.outputdir_input  -column 1 -row 2




#################################################################################
#optionsFrame has optionsFrame1, optionsFrame2, and optionsFrame3
set hjoin 0
radiobutton $optionsFrame1.joinEOL    -text "split on hyphen only at eol" -variable hjoin -value 0
radiobutton $optionsFrame1.joinAlways -text "split on hyphen always"      -variable hjoin -value 1
grid $optionsFrame1.joinEOL    -sticky w
grid $optionsFrame1.joinAlways -sticky w
#--------------------------------------------------------------------------------
#optionsFrame3
set usedigits 0
radiobutton $optionsFrame3.noincdigits  -text "don't include digits"  -variable usedigits -value 0
radiobutton $optionsFrame3.includigits  -text "include digits"        -variable usedigits -value 1
grid $optionsFrame3.noincdigits -sticky w
grid $optionsFrame3.includigits -sticky w
#--------------------------------------------------------------------------------
#optionsFrame
pack $optionsFrame.options_frame1 -side left
pack $optionsFrame.options_frame3 -side right



#################################################################################
#outputFrame has csvFrame, allFrame, plotFrame, and saveToFrame
#csvFrame
set csv 0
radiobutton $csvFrame.yes  -text "Yes"   -variable csv -value 1
radiobutton $csvFrame.no   -text "No"    -variable csv -value 0
grid $csvFrame.yes -sticky w
grid $csvFrame.no  -sticky w
#--------------------------------------------------------------------------------
#allFrame
set all 0
radiobutton $allFrame.yes  -text "Yes"   -variable all -value 1
radiobutton $allFrame.no   -text "No"    -variable all -value 0
grid $allFrame.yes -sticky w
grid $allFrame.no  -sticky w
#--------------------------------------------------------------------------------
#plotFrame
set plot 0
radiobutton $plotFrame.yes  -text "Yes" -variable plot -value 1
radiobutton $plotFrame.no -text "No"    -variable plot -value 0
grid $plotFrame.yes -sticky w
grid $plotFrame.no  -sticky w
#--------------------------------------------------------------------------------
#saveToFrame
set saveTo 0
radiobutton $saveToFrame.yes  -text "Yes"   -variable saveTo -value 1
radiobutton $saveToFrame.no   -text "No"    -variable saveTo -value 0
grid $saveToFrame.yes -sticky w
grid $saveToFrame.no  -sticky w
#--------------------------------------------------------------------------------
#outputFrame
pack $outputFrame.all_frame    -side left
pack $outputFrame.csv_frame    -side left
pack $outputFrame.plot_frame   -side left
pack $outputFrame.saveTo_frame -side right




#################################################################################
#gnuplotFrame has zoomFrame, labelsFrame, and replotFrame
#zoomFrame
set xmin 0
set xmax 1
set ymax 1
set xmin_input  [entry $zoomFrame.xmin_input  -textvariable xmin]
set xmin_prompt [label $zoomFrame.xmin_prompt -text "X Min Value" ]
set xmax_input  [entry $zoomFrame.xmax_input  -textvariable xmax]
set xmax_prompt [label $zoomFrame.xmax_prompt -text "X Max Value" ]
set ymax_input  [entry $zoomFrame.ymax_input  -textvariable ymax]
set ymax_prompt [label $zoomFrame.ymax_prompt -text "Y Max Value" ]
grid $zoomFrame.xmin_prompt -column 0 -row 0
grid $zoomFrame.xmin_input  -column 1 -row 0
grid $zoomFrame.xmax_prompt -column 0 -row 1
grid $zoomFrame.xmax_input  -column 1 -row 1
grid $zoomFrame.ymax_prompt -column 0 -row 2
grid $zoomFrame.ymax_input  -column 1 -row 2

#--------------------------------------------------------------------------------
#labelsFrame
set includelabels 0
radiobutton $labelsFrame.yes  -text "Yes" -variable includelabels -value 1
radiobutton $labelsFrame.no   -text "No"  -variable includelabels -value 0
grid $labelsFrame.yes -sticky w
grid $labelsFrame.no  -sticky w
#--------------------------------------------------------------------------------
#gnuplotFrame
pack $gnuplotFrame.zoom_frame    -side left
pack $gnuplotFrame.labels_frame  -side left


#################################################################################
#buttonFrame contains 4 clickable buttons
set quit_button   [button $buttonFrame.quit_button -text "Quit" -command "exit"]
set do_zwc_button [button $buttonFrame.do_zwc_button -text "RUN the zwc program" -command {do_run $hjoin $usedigits $csv $all $plot $saveTo $textFrame $ipathandfilename $ofilename $outputdir} ]
set help_button   [button $buttonFrame.help_button -text "Run zwc -h (help)" -command {do_run_help $textFrame } ]
set info_button   [button $buttonFrame.info_button -text "Run zwc -i (info)" -command {do_run_info $textFrame } ]
pack $buttonFrame.quit_button   -side left 
pack $buttonFrame.do_zwc_button -side right 
pack $buttonFrame.info_button   -side right
pack $buttonFrame.help_button   -side right 


#################################################################################
#All frames
grid $filenameFrame.ipathandfilename_prompt -column 0 -row 0

grid $filenameFrame -sticky w -pady 5
grid $optionsFrame  -sticky w -pady 5
grid $outputFrame   -sticky w -pady 5
grid $buttonFrame   -sticky w -pady 5
grid $gnuplotFrame  -sticky w -pady 5
grid .text_label_frame -sticky s -pady 5

pack .text_frame .sbar_x -in .text_label_frame            -fill x
pack .text_frame .sbar_y -in .text_label_frame -side left -fill y


#-----------------------------------------------------------------------------
proc do_run {hjoin usedigits csv all plot saveTo textFrame ipathandfilename ofilename outputdir} {
# only gnuplot and html need to know the filename split out from the path.
set ifilename [file tail $ipathandfilename ] 

    .text_frame delete 1.0 end
    if { $csv == 0 } {
        set csv_mode ""
    } else {
        set csv_mode -c 
    }
    if { $all == 0 } {
        set all_mode ""
    } else {
        set all_mode -a 
    }
    if { $hjoin == 0 } {
        set hjoin_mode ""
    } else {
        set hjoin_mode -s 
    }
    if { $usedigits == 0 } {
        set usedigits_mode ""
    } else {
        set usedigits_mode -d 
    }
    if { $outputdir == "" } {
    set outputdir_mode "" 
    } else {
    set outputdir_mode -o 
    }

    set USE_STDOUT [string equal $ofilename "STDOUT"]
    if { $USE_STDOUT } {
        .text_frame insert end "The command is zwc $hjoin_mode $usedigits_mode $csv_mode $all_mode $outputdir_mode $outputdir -f $ipathandfilename\n" 
        .text_frame see end
        set the_output [exec ./zwc $hjoin_mode $usedigits_mode $csv_mode $all_mode $outputdir_mode $outputdir -f $ipathandfilename | tee qfacts.tmp]
    } else {
        .text_frame insert end "The command is zwc $hjoin_mode $usedigits_mode $csv_mode $all_mode $outputdir_mode $outputdir -f $ipathandfilename > $ofilename\n" 
        .text_frame see end
        set the_output [exec ./zwc $hjoin_mode $usedigits_mode $csv_mode $all_mode $outputdir_mode $outputdir -f $ipathandfilename | tee qfacts.tmp >& $ofilename]
    }
        .text_frame insert end "$the_output\n" 
        .text_frame see end 

    # Maybe attempt to run gnuplot means attempting to "source <infile>.sourceme
    if { $plot == 1 } {
       set gnuplotsourcemes [open "$outputdir/$ifilename.sourceme" w]
       puts $gnuplotsourcemes "gnuplot -background white -persist $ifilename.WRPROF.dat\ngnuplot -background white -persist $ifilename.WSLNW.dat\ngnuplot -background white -persist $ifilename.WCvsRANK.dat\n"
       close $gnuplotsourcemes
        set throwaway1 [ exec $::env(SHELL) -c "cd $outputdir ; source $ifilename.sourceme ; cd .." ]
    }

    ################  Writing the HTML ################
    if { $saveTo == 1 } {
    # Attempt to save this run as an html file. 
    # NOTE: zwc will work with the path/filename and split out the filename. This script
    # separately splits out the filename after passing ipathandfilename in full to zwc.
        set hfilename "$ifilename.html"
        set htmlfileId [open $outputdir/$hfilename "w"]
        puts -nonewline $htmlfileId "<html><head><title>\n"
        puts -nonewline $htmlfileId "$ifilename\n"
        puts -nonewline $htmlfileId "</title></head><body>\n"
        puts -nonewline $htmlfileId "<table><tr><td>\n"
        puts -nonewline $htmlfileId "<img src=\"$ifilename.WCvsRANK.png\">"
        puts -nonewline $htmlfileId "</td><td>\n"
        puts -nonewline $htmlfileId "Statistics on the text file <b>$ifilename</b>, using the command:"
        puts -nonewline $htmlfileId "<br><i>zwc $hjoin_mode $usedigits_mode $csv_mode $outputdir_mode $outputdir -f $ipathandfilename</i>"
        puts -nonewline $htmlfileId [exec grep QFACT qfacts.tmp | sed s/#\ QFACT:/<br>/ ]
        puts -nonewline $htmlfileId "</td></tr></table>\n"
        puts -nonewline $htmlfileId "<hr width=80%>\n"
        puts -nonewline $htmlfileId "<br><img src=\"$ifilename.WSLNW.png\n\">"
        puts -nonewline $htmlfileId "<hr width=80%>\n"
        puts -nonewline $htmlfileId "<br><img src=\"$ifilename.WRPROF.png\n\">"
        puts -nonewline $htmlfileId "</body></html>\n"
        close $htmlfileId
    }
}

#-----------------------------------------------------------------------------
proc do_run_help {textFrame} {
    .text_frame delete 1.0 end
    .text_frame insert end "The command is zwc -help\n"
    .text_frame see end
    set the_output [exec ./zwc -help]
    .text_frame insert end "$the_output\n" 
    .text_frame see end
}

#-----------------------------------------------------------------------------
proc do_run_info {textFrame} {
    .text_frame delete 1.0 end
    .text_frame insert end "The command is zwc -info\n"
    .text_frame see end
    set the_output [exec ./zwc -info]
    .text_frame insert end "$the_output\n"
    .text_frame see end
}

#-----------------------------------------------------------------------------
# This expects three fields, word rank, count, and the word
proc do_replot { outputdir ipathandfilename textFrame xmin xmax ymax includelabels } {
set ifilename [file tail $ipathandfilename ] 
    if { $includelabels == 1 } {
       set the_output [exec grep \[A-Za-z\] $outputdir\/$ifilename.WRPROF.csv > zoom.csv]
       set zoomfile [open "zoom.dat" w]
       puts $zoomfile "set xrange \[ $xmin : $xmax \] \; set yrange \[$xmin : $ymax\] ; set terminal png ; set output \"zoom.png\" ; plot \"zoom.csv\" using 1:2:3 with labels tc lt 2 ; set terminal x11 ; replot"
       close $zoomfile
       set the_output [exec gnuplot -background white -persist zoom.dat ]
    } else {
       set zoomfile [open "zoom.dat" w]
       puts $zoomfile "set xrange \[ $xmin : $xmax \] \; set terminal png ; set output \"zoom.png\" ; plot \"zoom.csv\" w points 0; set terminal x11 ; replot"
       close $zoomfile
       file copy -force $outputdir\/$ifilename.WRPROF.csv  zoom.csv
       set the_output [exec gnuplot -background white -persist zoom.dat ]
    }
}


#-----------------------------------------------------------------------------
proc showAboutZwc_gui {} {
          tk_messageBox -message "
--This is a GUI wrapper for the zwc program, for creating the command line options and launching zwc.

--It also adds options to invoke GNUPlot using the .dat and .csv files zwc generated, to create an HTML page summary, and to zoom in on an area of interest in the WRPROF plot.

--The \"Input and Output Files\" section, the -s, -d, -c, and -a options are directly passed to zwc.

--The \"Run GNUPlot?\" and the \"HTML summary?\" options are specific to this script and pretty much do what they describe. The -a option should be selected if either of these plot or html options is desired.

--The section titled \"WRPROF Replotting Options\", which also requires the -a option, will replot the WRPROF plot but only with the range entered.

" -title "About Zwc_gui"
     }

#-----------------------------------------------------------------------------
proc showAboutZwc {} {
          tk_messageBox -message "
This script is pointless without the program zwc. For information on zwc try \"zwc -i\" or \"zwc -h\"
" -title "About zwc"
     }

#-----------------------------------------------------------------------------
proc showAboutZipfsLaw {} {
          tk_messageBox -message "
A good place to learn about Zipf's Law is Wikipedia.
" -title "About Zipf's Law"
     }


