#ifndef ZWORDCOUNT_H
#define ZWORDCOUNT_H 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>

int verbose ;

struct word_struct {
  int valid ;                    /* This is for priming the tree. See zsearcherInit */
  char* word ;                   /* The word itself */
  int count ;                    /* This word's frequency */
  int* hittimes ;                /* An ever growing array of the current wordcount each match */
  struct word_struct* left ;     /* A pointer to the left  node in the binary sorted tree */
  struct word_struct* right ;    /* A pointer to the right node in the binary sorted tree */
  struct word_struct* prev ;     /* A pointer to the previous node in the list by word arrival time */
  struct word_struct* next ;     /* A pointer to the next     node in the list by word arrival time */
  struct word_struct* fwrd ;     /* A pointer to the next     node in the list by word Frequency */
  struct word_struct* back ;     /* A pointer to the previous node in the list by word Frequency */
} ;

typedef struct word_struct node ;

// zsearcher  calls pushWSLNW every new word, but is unaware of what happens. 
// zwordcount calls pushWSLNW once only with the filename to initialize it.
void pushWSLNW  (int wordcount, int finish, char* filename) ;

void leave  (node* anode) ;

#endif

